freeslot("MT_KINGBOO_CHASE")
freeslot("MT_CACOFIRE_SLOW")
freeslot("sfx_kboo1", "sfx_kboo2", "sfx_kboo3", "sfx_kboo4", "sfx_kboo5", "sfx_kboo6" ,"sfx_kboo7" ,"sfx_kboo8" ,"sfx_kboo9")

addHook("BossThinker",function(mobj)
    if mobj.movementtimer == nil then mobj.movementtimer = 0 end
	if mobj.throwfireball == nil then mobj.throwfireball = 0 end
	if mobj.firstactiontimer == nil then mobj.firstactiontimer = 0 end
	if mobj.firstatk == nil then mobj.firstatk = false end
    if mobj.secondactiontimer == nil then mobj.secondactiontimer = 0 end
	if mobj.secondatk == nil then mobj.secondatk = false end
	if mobj.thirdactiontimer == nil then mobj.thirdactiontimer = 0 end
	if mobj.thirdatk == nil then mobj.thirdatk = false end
	if mobj.rushmode == nil then mobj.rushmode = false end
	if mobj.rushtimer == nil then mobj.rushtimer = 0 end
    if mobj and mobj.valid then
	    mobj.movementtimer = $1 + 1
		if mobj.firstatk == false then
		   mobj.firstactiontimer = $1 + 1
		end
		
		if mobj.secondatk == false then
		   mobj.secondactiontimer = $1 + 1
		end

		if mobj.thirdatk == false then
		   mobj.thirdactiontimer = $1 + 1
		end
		
		if mobj.state ~= S_KINGBOO_FIRE1 or mobj.state ~= S_KINGBOO_FIRE2 or mobj.state ~= S_KINGBOO_FIRE3 or mobj.state ~= S_KINGBOO_FIRE4 or mobj.rushmode ~= true then
		   P_InstaThrust(mobj, mobj.angle, FRACUNIT)
		   if mobj.movementtimer == 20 then
		      P_SetObjectMomZ(mobj, FRACUNIT, false)
		   elseif mobj.movementtimer == 60 then
		      P_SetObjectMomZ(mobj, -FRACUNIT, false)
		   end
        else
		   P_SetObjectMomZ(mobj, 0, true)
		   P_InstaThrust(mobj, mobj.angle, 0)
		end
		
		if mobj.state == S_KINGBOO_FIRE3 then
		   mobj.blueflames = P_SpawnMissile(mobj, mobj.target, MT_FLAMEJETFLAME)
		   if mobj.blueflames and mobj.blueflames.valid then
		      mobj.blueflames.color = SKINCOLOR_BLUE
			  mobj.blueflames.colorized = true
		   end
		end
		
		if mobj.state == S_KINGBOO_CHASE1 then
		   mobj.throwfireball = $1 + 1
		end
		
		if mobj.throwfireball >= 90 then
		   mobj.throwfireball = 0
		   mobj.state = S_KINGBOO_THROW1
		end
		
		if mobj.firstactiontimer >= 1200 then
		   mobj.state = S_KINGBOO_FIRE1
		   mobj.firstatk = true
		   mobj.firstactiontimer = 0
		end
		
	    if mobj.secondactiontimer >= 1400 then
		   P_LinedefExecute(82)
		   mobj.rushmode = true
		   mobj.secondatk = true
		   mobj.secondactiontimer = 0
		   S_StartSound(nil, sfx_kboo2)
		end
		
		
		if mobj.thirdactiontimer >= 1500 then
		   P_LinedefExecute(42)
		end
		
		if mobj.thirdactiontimer >= 2200 then
		   P_LinedefExecute(57)
		end
		
		if mobj.thirdactiontimer >= 2350 and mobj.thirdactiontimer <= 2351 then
		   mobj.rushmode = true
		end
		
		if mobj.thirdactiontimer >= 2500 and mobj.thirdactiontimer < 2501 then
		   mobj.state = S_KINGBOO_FIRE1
		end
		
		if mobj.thirdactiontimer >= 2600 then
		   P_LinedefExecute(67)
		end

		if mobj.thirdactiontimer >= 2700 then
		   P_LinedefExecute(68)
		end

		if mobj.thirdactiontimer >= 2800 then
		   P_LinedefExecute(69)
		end

		if mobj.thirdactiontimer >= 3000 then
		   P_LinedefExecute(70)
		end
		
		if mobj.rushmode == true then
		   mobj.rushtimer = $1 + 1
		   P_InstaThrust(mobj, mobj.angle, 30*FRACUNIT)
		   P_SpawnGhostMobj(mobj)
		end
		
		if mobj.rushtimer >= 30 then
		   mobj.rushtimer = 0
		   mobj.rushmode = false
		   P_SetObjectMomZ(mobj, 0, true)
		   P_InstaThrust(mobj, mobj.angle, 0)
		end
		
		if mobj.firstactiontimer >= 150 then
		   P_LinedefExecute(34)
		end
		
	    if mobj.firstactiontimer >= 300 then
		   P_LinedefExecute(35)
		end
		
		if mobj.firstactiontimer >= 550 then
		   P_LinedefExecute(36)
		end
		
		if mobj.firstactiontimer >= 700 then
		   P_LinedefExecute(51)
		end
		
		if mobj.firstactiontimer >= 850 then
		   P_LinedefExecute(52)
		end
		
		if mobj.firstactiontimer >= 1000 then
		   P_LinedefExecute(53)
		end
		
		if mobj.state == S_KINGBOO_INTRO1 and mobj.tics == 240 then
		   S_StartSound(mobj, sfx_kboo6)
		end
		
		if mobj.state == S_KINGBOO_THROW3 and mobj.tics == 14 then
		   S_StartSound(mobj, sfx_kboo3)
		end
		
		if mobj.state == S_KINGBOO_FIRE1 and mobj.tics == 40 then
		   S_StartSound(nil, sfx_kboo7)
		end
		
	    if mobj.state == S_KINGBOO_FIRE2 and mobj.tics == 7 then
		   S_StartSound(nil, sfx_kboo8)
		   P_LinedefExecute(30)
		end
		
		if mobj.thirdactiontimer >= 2200 and mobj.thirdactiontimer < 2201 then
		   S_StartSound(nil, sfx_kboo5)
		end
		
		if mobj.health == 0 then
		   P_LinedefExecute(73)
		   P_SpawnGhostMobj(mobj)
		end
	end
	if mobj.movementtimer >= 70 then
	   mobj.movementtimer = 0
	end
	mobj.scale = 2*FRACUNIT
end, MT_KINGBOO_CHASE)

addHook("MobjThinker",function(mobj)
     if mobj and mobj.valid then
         mobj.fireparticle = P_SpawnMobjFromMobj(mobj, FRACUNIT*P_RandomRange(-16,16), FRACUNIT*P_RandomRange(-16,16), FRACUNIT*P_RandomRange(0,8), MT_FIREBALLTRAIL)
		 if mobj.fireparticle and mobj.fireparticle.valid then
		    mobj.fireparticle.color = SKINCOLOR_BLUE
			mobj.fireparticle.colorized = true
			mobj.fireparticle.scale = FRACUNIT/2
		 end
	 end
	 mobj.scale = 2*FRACUNIT
end, MT_CACOFIRE_SLOW)

//TRIGGER FOR THE BOSS TO FUCKING DIE BY THE SUUUUUUUUUUUUUUUUUN
//PRAISE THE SUUUUUUUUUUUUUUUUUUUUUN MY BROTHER
local function MakeATriggerForMobjsNextTimeSTJR(line)
   for linedef in lines.iterate do
      if linedef.tag == 79 then
	     linedef.frontside.textureoffset = 0
	  end
   end
end

addHook("LinedefExecute", MakeATriggerForMobjsNextTimeSTJR, "LINESHIT")

addHook("MobjLineCollide", function(mobj, line)
    if mobj.juststop == nil then mobj.juststop = false end
	
    if line.tag == 79 and mobj.juststop == false then
	   if line.frontside.textureoffset == 0 then
          mobj.health = 0
          mobj.state = mobjinfo[MT_KINGBOO_CHASE].deathstate
		  mobj.juststop = true
       end
	end
end, MT_KINGBOO_CHASE)

addHook("MobjCollide", function(mobj, mobj_target)
    if mobj_target.type == MT_PLAYER then
       P_DamageMobj(mobj_target, mobj, mobj, 1, DMG_INSTAKILL)
    end
end, MT_KINGBOO_CHASE)