freeslot("MT_HALLOWEEN_BOSS4")
freeslot("MT_HALLOWEEN_BOSS4_SUM")
freeslot("MT_HALLOWEEN_BOSS4_DARK")
freeslot("MT_GHOSTDANCE_FUNI")

addHook("BossThinker",function(mobj)	
    if mobj.didslam == nil then mobj.didslam = false end
	if mobj.summontimer == nil then mobj.summontimer = 0 end
	if mobj.dotransform == nil then mobj.dotransform = false end
	
    if mobj and mobj.valid then
	
	   if mobj.health <= 1 and mobj.dotransform == false then
	      mobj.state = S_HALLOWEENBOSS4_TRANSFORM1
		  mobj.dotransform = true
	   end
	   if mobj.state == S_HALLOWEENBOSS4_SLAM1 and mobj.tics == 35 then
	      P_SetObjectMomZ(mobj, 10*FRACUNIT)
		  mobj.frame = A
		  mobj.didslam = false
		  mobj.flags = $1 & ~MF_SHOOTABLE
	      mobj.flags = $1 & ~MF_SPECIAL
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4_SLAM2 then
	      if mobj.tics == 25 then
	         P_SetObjectMomZ(mobj, -30*FRACUNIT)
		     mobj.frame = C		     
		  end
		  
		  if P_IsObjectOnGround(mobj) == true and mobj.didslam == false then
		     for a = 1, 36
		         mobj.cacocircle = P_SPMAngle(mobj, MT_CACOFIRE, (mobj.angle-360*ANG1)+((a*5)*ANG2))
	         end
			 mobj.didslam = true
		  end
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4_SLAM3 and mobj.tics == 50 then
	      P_SetObjectMomZ(mobj, FRACUNIT)
		  mobj.frame = B
		  mobj.flags = $1|MF_SHOOTABLE
	      mobj.flags = $1|MF_SPECIAL
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4_SUMMON1 and mobj.tics == 20 then
	      if mobj.tics == 20 then
		     P_SetObjectMomZ(mobj, 5*FRACUNIT)
		  end
		  
		  if mobj.tics == 5 then
		     P_SetObjectMomZ(mobj, 0)
		  end
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4_SUMMON2 then
	      mobj.flags = $1 & ~MF_SHOOTABLE
	      mobj.summontimer = $1 + 1
		  if mobj.summontimer >= 60 then
		     P_SpawnMissile(mobj, mobj.target, MT_HALLOWEEN_BOSS4_SUM)
		     mobj.summontimer = 0
		  end
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4_SUMMON3 then
	      if mobj.tics == 60 then
		     P_SetObjectMomZ(mobj, -5*FRACUNIT)
		  end
	      mobj.flags = $1|MF_SHOOTABLE
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4_PAIN1 and mobj.tics == 20 then
	      mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.target.x, mobj.target.y)
          mobj.rotatingfire = P_SpawnMobjFromMobj(mobj, mobj.x, mobj.y, mobj.z, MT_SPINBOBERT_FIRE1)
	      if mobj.rotatingfire and mobj.rotatingfire.valid then
		     mobj.rotatingfire.target = mobj
	         mobj.rotatingfire.scale = 2*FRACUNIT
	      end
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4_PAIN2 and mobj.tics == 35 then
	      P_InstaThrust(mobj, mobj.angle, -20*FRACUNIT)
		  P_SetObjectMomZ(mobj, 2*FRACUNIT)
	   end
	end
end, MT_HALLOWEEN_BOSS4)

addHook("MobjSpawn",function(mobj)
    mobj.scale = 2*FRACUNIT
end, MT_HALLOWEEN_BOSS4)

addHook("MobjThinker",function(mobj)
   if mobj and mobj.valid then
      P_SpawnGhostMobj(mobj)
   end
end, MT_HALLOWEEN_BOSS4_SUM)

addHook("MobjSpawn",function(mobj)
    mobj.colorized = true
	mobj.color = SKINCOLOR_BONE
end, MT_HALLOWEEN_BOSS4_SUM)

addHook("ShouldDamage", function(mobj, inflictor)
    if inflictor and inflictor.valid then  ---CHECK UR SHIT AGAIN
	   if inflictor.type == MT_CACOFIRE and mobj.type == MT_HALLOWEEN_BOSS4 then
	      return false
	   end
    end
end, MT_HALLOWEEN_BOSS4)

addHook("BossThinker",function(mobj)	
    if mobj.didslam == nil then mobj.didslam = false end
	if mobj.summontimer == nil then mobj.summontimer = 0 end
	if mobj.dotransform == nil then mobj.dotransform = false end
	if mobj.sparkletimer == nil then mobj.sparkletimer = 0 end
	if mobj.firetimer == nil then mobj.firetimer = 0 end
	
    if mobj and mobj.valid then
	   if mobj.state == S_HALLOWEENBOSS4DARK_FIRE1 then
	      mobj.flags = $1 & ~MF_SHOOTABLE
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4DARK_FIRE2 then
	      mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.target.x, mobj.target.y)
	      mobj.firetimer = $1 + 1
		  if mobj.firetimer >= 6 then
			 mobj.cacofire_white = P_SpawnMissile(mobj, mobj.target, MT_CACOFIRE)
		     if mobj.cacofire_white and mobj.cacofire_white.valid then
				mobj.cacofire_white.scale = 2*FRACUNIT
			    mobj.cacofire_white.colorized = true
				mobj.cacofire_white.color = SKINCOLOR_CLOUDY
		     end
		  end
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4DARK_FIRE3 then
	      mobj.flags = $1|MF_SHOOTABLE
	   end
		
	   if mobj.state == S_HALLOWEENBOSS4DARK_FLY1 then
	      mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.target.x, mobj.target.y)
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4DARK_FLY2 then
	      mobj.sparkletimer = $1 + 1
		  if mobj.sparkletimer >= 2 then
		     mobj.particles = P_SpawnMobjFromMobj(mobj,FRACUNIT*P_RandomRange(-16,16),FRACUNIT*P_RandomRange(-16,16),FRACUNIT*P_RandomRange(0,32),MT_BOXSPARKLE)
		     if mobj.particles and mobj.particles.valid then
		        mobj.particles.colorized = true
		        mobj.particles.color = SKINCOLOR_WHITE
		     end
		     mobj.sparkletimer = 0
		  end
		  
	      if mobj.tics == 50 then
		     mobj.flags = $1 & ~MF_SHOOTABLE
	         mobj.flags = $1 & ~MF_SPECIAL
		     mobj.flags = $1|MF_PAIN
		  end
		  
	      if mobj.tics <= 30 then
		     mobj.flags = $1|MF_SHOOTABLE
	         mobj.flags = $1|MF_SPECIAL
		     mobj.flags = $1 & ~MF_PAIN
		  end
	      P_SpawnGhostMobj(mobj)
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4DARK_FLY3 then
	      mobj.flags = $1|MF_SHOOTABLE
	      mobj.flags = $1|MF_SPECIAL
		  mobj.flags = $1 & ~MF_PAIN
	      if mobj.tics == 55 then
		     P_SetObjectMomZ(mobj, FRACUNIT)
			 P_InstaThrust(mobj, mobj.angle, -10*FRACUNIT)
			 S_StartSound(nil, sfx_s239)
		  end
	   end
	  
	   if mobj.state == S_HALLOWEENBOSS4DARK_PAIN2 and mobj.tics == 35 then
	      mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.target.x, mobj.target.y)
	      P_InstaThrust(mobj, mobj.angle, -20*FRACUNIT)
		  P_SetObjectMomZ(mobj, 2*FRACUNIT)
	   end
	   
	   if mobj.state == S_HALLOWEENBOSS4DARK_DEATH then
	      mobj.colorized = true
		  mobj.color = SKINCOLOR_SILVER
		  P_SpawnGhostMobj(mobj)
	   end
	end
end, MT_HALLOWEEN_BOSS4_DARK)

addHook("MobjSpawn",function(mobj)
    mobj.scale = 2*FRACUNIT
end, MT_HALLOWEEN_BOSS4_DARK)

addHook("MobjSpawn",function(mobj)
    mobj.scale = FRACUNIT/2
end, MT_GHOSTDANCE_FUNI)